image: gcr.io/kaniko-project/executor:debug

variables:
  REGISTRY_URL: https://index.docker.io/v1/
  DOCKER_IMAGE: trobert2/aws-cli
  DOCKER_TAG: latest

.dev_variables: &dev_variables
  DOCKER_TAG: ${CI_COMMIT_SHA}

stages:
- test
- build

.before_script: &before_script
  before_script:
  - mkdir -p /kaniko/.docker
  - echo "{\"auths\":{\"${REGISTRY_URL}\":{\"username\":\"${DOCKER_USERNAME}\",\"password\":\"${DOCKER_PASSWORD}\"}}}" > /kaniko/.docker/config.json

.build_script: &build_script
  script:
  - /kaniko/executor --context $CI_PROJECT_DIR --dockerfile $CI_PROJECT_DIR/Dockerfile --destination $DOCKER_IMAGE:$DOCKER_TAG

test:
  stage: build
  image:
    name: gcr.io/kaniko-project/executor:debug
    entrypoint: [""]
  <<: *before_script
  <<: *build_script
  variables:
    <<: *dev_variables
  only:
  - merge_request
  tags:
  - docker

build:
  stage: build
  image:
    name: gcr.io/kaniko-project/executor:debug
    entrypoint: [""]
  <<: *before_script
  <<: *build_script
  only:
  - master
  tags:
  - docker
